use ::libc;
use ::c2rust_asm_casts;
use c2rust_asm_casts::AsmCastTrait;
extern "C" {
    pub type _IO_wide_data;
    pub type _IO_codecvt;
    pub type _IO_marker;
    #[no_mangle]
    static mut stderr: *mut FILE;
    #[no_mangle]
    fn fflush(__stream: *mut FILE) -> libc::c_int;
    #[no_mangle]
    fn sprintf(_: *mut libc::c_char, _: *const libc::c_char, _: ...)
     -> libc::c_int;
    #[no_mangle]
    fn vfprintf(_: *mut FILE, _: *const libc::c_char, _: ::std::ffi::VaList)
     -> libc::c_int;
    #[no_mangle]
    fn sscanf(_: *const libc::c_char, _: *const libc::c_char, _: ...)
     -> libc::c_int;
    #[no_mangle]
    fn atoi(__nptr: *const libc::c_char) -> libc::c_int;
    #[no_mangle]
    fn select(__nfds: libc::c_int, __readfds: *mut fd_set,
              __writefds: *mut fd_set, __exceptfds: *mut fd_set,
              __timeout: *mut timeval) -> libc::c_int;
    #[no_mangle]
    fn getenv(__name: *const libc::c_char) -> *mut libc::c_char;
    #[no_mangle]
    fn memcpy(_: *mut libc::c_void, _: *const libc::c_void, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memset(_: *mut libc::c_void, _: libc::c_int, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn strncpy(_: *mut libc::c_char, _: *const libc::c_char, _: libc::c_ulong)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strchr(_: *const libc::c_char, _: libc::c_int) -> *mut libc::c_char;
    #[no_mangle]
    fn strtok(_: *mut libc::c_char, _: *const libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strlen(_: *const libc::c_char) -> libc::c_ulong;
    #[no_mangle]
    fn __errno_location() -> *mut libc::c_int;
    #[no_mangle]
    fn close(__fd: libc::c_int) -> libc::c_int;
    #[no_mangle]
    fn socket(__domain: libc::c_int, __type: libc::c_int,
              __protocol: libc::c_int) -> libc::c_int;
    #[no_mangle]
    fn connect(__fd: libc::c_int, __addr: *const sockaddr, __len: socklen_t)
     -> libc::c_int;
    #[no_mangle]
    fn getsockopt(__fd: libc::c_int, __level: libc::c_int,
                  __optname: libc::c_int, __optval: *mut libc::c_void,
                  __optlen: *mut socklen_t) -> libc::c_int;
    #[no_mangle]
    fn gettimeofday(__tv: *mut timeval, __tz: __timezone_ptr_t)
     -> libc::c_int;
    #[no_mangle]
    fn poll(__fds: *mut pollfd, __nfds: nfds_t, __timeout: libc::c_int)
     -> libc::c_int;
    #[no_mangle]
    fn strftime(__s: *mut libc::c_char, __maxsize: size_t,
                __format: *const libc::c_char, __tp: *const tm) -> size_t;
    #[no_mangle]
    fn localtime(__timer: *const time_t) -> *mut tm;
    #[no_mangle]
    fn clock_gettime(__clock_id: clockid_t, __tp: *mut timespec)
     -> libc::c_int;
    #[no_mangle]
    fn eventfd_read(__fd: libc::c_int, __value: *mut eventfd_t)
     -> libc::c_int;
    #[no_mangle]
    fn sysconf(__name: libc::c_int) -> libc::c_long;
    #[no_mangle]
    fn ioctl(__fd: libc::c_int, __request: libc::c_ulong, _: ...)
     -> libc::c_int;
    #[no_mangle]
    fn getaddrinfo(__name: *const libc::c_char,
                   __service: *const libc::c_char, __req: *const addrinfo,
                   __pai: *mut *mut addrinfo) -> libc::c_int;
    #[no_mangle]
    fn freeaddrinfo(__ai: *mut addrinfo);
    #[no_mangle]
    fn fcntl(__fd: libc::c_int, __cmd: libc::c_int, _: ...) -> libc::c_int;
}
pub type __builtin_va_list = [__va_list_tag; 1];
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __va_list_tag {
    pub gp_offset: libc::c_uint,
    pub fp_offset: libc::c_uint,
    pub overflow_arg_area: *mut libc::c_void,
    pub reg_save_area: *mut libc::c_void,
}
pub type size_t = libc::c_ulong;
pub type va_list = __builtin_va_list;
pub type __uint8_t = libc::c_uchar;
pub type __uint16_t = libc::c_ushort;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type __off_t = libc::c_long;
pub type __off64_t = libc::c_long;
pub type __time_t = libc::c_long;
pub type __suseconds_t = libc::c_long;
pub type __clockid_t = libc::c_int;
pub type __syscall_slong_t = libc::c_long;
pub type __caddr_t = *mut libc::c_char;
pub type __socklen_t = libc::c_uint;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct _IO_FILE {
    pub _flags: libc::c_int,
    pub _IO_read_ptr: *mut libc::c_char,
    pub _IO_read_end: *mut libc::c_char,
    pub _IO_read_base: *mut libc::c_char,
    pub _IO_write_base: *mut libc::c_char,
    pub _IO_write_ptr: *mut libc::c_char,
    pub _IO_write_end: *mut libc::c_char,
    pub _IO_buf_base: *mut libc::c_char,
    pub _IO_buf_end: *mut libc::c_char,
    pub _IO_save_base: *mut libc::c_char,
    pub _IO_backup_base: *mut libc::c_char,
    pub _IO_save_end: *mut libc::c_char,
    pub _markers: *mut _IO_marker,
    pub _chain: *mut _IO_FILE,
    pub _fileno: libc::c_int,
    pub _flags2: libc::c_int,
    pub _old_offset: __off_t,
    pub _cur_column: libc::c_ushort,
    pub _vtable_offset: libc::c_schar,
    pub _shortbuf: [libc::c_char; 1],
    pub _lock: *mut libc::c_void,
    pub _offset: __off64_t,
    pub _codecvt: *mut _IO_codecvt,
    pub _wide_data: *mut _IO_wide_data,
    pub _freeres_list: *mut _IO_FILE,
    pub _freeres_buf: *mut libc::c_void,
    pub __pad5: size_t,
    pub _mode: libc::c_int,
    pub _unused2: [libc::c_char; 20],
}
pub type _IO_lock_t = ();
pub type FILE = _IO_FILE;
pub type clockid_t = __clockid_t;
pub type time_t = __time_t;
pub type u_int8_t = __uint8_t;
pub type u_int16_t = __uint16_t;
pub type u_int32_t = __uint32_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct timeval {
    pub tv_sec: __time_t,
    pub tv_usec: __suseconds_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct timespec {
    pub tv_sec: __time_t,
    pub tv_nsec: __syscall_slong_t,
}
pub type __fd_mask = libc::c_long;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct fd_set {
    pub __fds_bits: [__fd_mask; 16],
}
pub type socklen_t = __socklen_t;
pub type C2RustUnnamed = libc::c_uint;
pub const _SC_THREAD_ROBUST_PRIO_PROTECT: C2RustUnnamed = 248;
pub const _SC_THREAD_ROBUST_PRIO_INHERIT: C2RustUnnamed = 247;
pub const _SC_XOPEN_STREAMS: C2RustUnnamed = 246;
pub const _SC_TRACE_USER_EVENT_MAX: C2RustUnnamed = 245;
pub const _SC_TRACE_SYS_MAX: C2RustUnnamed = 244;
pub const _SC_TRACE_NAME_MAX: C2RustUnnamed = 243;
pub const _SC_TRACE_EVENT_NAME_MAX: C2RustUnnamed = 242;
pub const _SC_SS_REPL_MAX: C2RustUnnamed = 241;
pub const _SC_V7_LPBIG_OFFBIG: C2RustUnnamed = 240;
pub const _SC_V7_LP64_OFF64: C2RustUnnamed = 239;
pub const _SC_V7_ILP32_OFFBIG: C2RustUnnamed = 238;
pub const _SC_V7_ILP32_OFF32: C2RustUnnamed = 237;
pub const _SC_RAW_SOCKETS: C2RustUnnamed = 236;
pub const _SC_IPV6: C2RustUnnamed = 235;
pub const _SC_LEVEL4_CACHE_LINESIZE: C2RustUnnamed = 199;
pub const _SC_LEVEL4_CACHE_ASSOC: C2RustUnnamed = 198;
pub const _SC_LEVEL4_CACHE_SIZE: C2RustUnnamed = 197;
pub const _SC_LEVEL3_CACHE_LINESIZE: C2RustUnnamed = 196;
pub const _SC_LEVEL3_CACHE_ASSOC: C2RustUnnamed = 195;
pub const _SC_LEVEL3_CACHE_SIZE: C2RustUnnamed = 194;
pub const _SC_LEVEL2_CACHE_LINESIZE: C2RustUnnamed = 193;
pub const _SC_LEVEL2_CACHE_ASSOC: C2RustUnnamed = 192;
pub const _SC_LEVEL2_CACHE_SIZE: C2RustUnnamed = 191;
pub const _SC_LEVEL1_DCACHE_LINESIZE: C2RustUnnamed = 190;
pub const _SC_LEVEL1_DCACHE_ASSOC: C2RustUnnamed = 189;
pub const _SC_LEVEL1_DCACHE_SIZE: C2RustUnnamed = 188;
pub const _SC_LEVEL1_ICACHE_LINESIZE: C2RustUnnamed = 187;
pub const _SC_LEVEL1_ICACHE_ASSOC: C2RustUnnamed = 186;
pub const _SC_LEVEL1_ICACHE_SIZE: C2RustUnnamed = 185;
pub const _SC_TRACE_LOG: C2RustUnnamed = 184;
pub const _SC_TRACE_INHERIT: C2RustUnnamed = 183;
pub const _SC_TRACE_EVENT_FILTER: C2RustUnnamed = 182;
pub const _SC_TRACE: C2RustUnnamed = 181;
pub const _SC_HOST_NAME_MAX: C2RustUnnamed = 180;
pub const _SC_V6_LPBIG_OFFBIG: C2RustUnnamed = 179;
pub const _SC_V6_LP64_OFF64: C2RustUnnamed = 178;
pub const _SC_V6_ILP32_OFFBIG: C2RustUnnamed = 177;
pub const _SC_V6_ILP32_OFF32: C2RustUnnamed = 176;
pub const _SC_2_PBS_CHECKPOINT: C2RustUnnamed = 175;
pub const _SC_STREAMS: C2RustUnnamed = 174;
pub const _SC_SYMLOOP_MAX: C2RustUnnamed = 173;
pub const _SC_2_PBS_TRACK: C2RustUnnamed = 172;
pub const _SC_2_PBS_MESSAGE: C2RustUnnamed = 171;
pub const _SC_2_PBS_LOCATE: C2RustUnnamed = 170;
pub const _SC_2_PBS_ACCOUNTING: C2RustUnnamed = 169;
pub const _SC_2_PBS: C2RustUnnamed = 168;
pub const _SC_USER_GROUPS_R: C2RustUnnamed = 167;
pub const _SC_USER_GROUPS: C2RustUnnamed = 166;
pub const _SC_TYPED_MEMORY_OBJECTS: C2RustUnnamed = 165;
pub const _SC_TIMEOUTS: C2RustUnnamed = 164;
pub const _SC_SYSTEM_DATABASE_R: C2RustUnnamed = 163;
pub const _SC_SYSTEM_DATABASE: C2RustUnnamed = 162;
pub const _SC_THREAD_SPORADIC_SERVER: C2RustUnnamed = 161;
pub const _SC_SPORADIC_SERVER: C2RustUnnamed = 160;
pub const _SC_SPAWN: C2RustUnnamed = 159;
pub const _SC_SIGNALS: C2RustUnnamed = 158;
pub const _SC_SHELL: C2RustUnnamed = 157;
pub const _SC_REGEX_VERSION: C2RustUnnamed = 156;
pub const _SC_REGEXP: C2RustUnnamed = 155;
pub const _SC_SPIN_LOCKS: C2RustUnnamed = 154;
pub const _SC_READER_WRITER_LOCKS: C2RustUnnamed = 153;
pub const _SC_NETWORKING: C2RustUnnamed = 152;
pub const _SC_SINGLE_PROCESS: C2RustUnnamed = 151;
pub const _SC_MULTI_PROCESS: C2RustUnnamed = 150;
pub const _SC_MONOTONIC_CLOCK: C2RustUnnamed = 149;
pub const _SC_FILE_SYSTEM: C2RustUnnamed = 148;
pub const _SC_FILE_LOCKING: C2RustUnnamed = 147;
pub const _SC_FILE_ATTRIBUTES: C2RustUnnamed = 146;
pub const _SC_PIPE: C2RustUnnamed = 145;
pub const _SC_FIFO: C2RustUnnamed = 144;
pub const _SC_FD_MGMT: C2RustUnnamed = 143;
pub const _SC_DEVICE_SPECIFIC_R: C2RustUnnamed = 142;
pub const _SC_DEVICE_SPECIFIC: C2RustUnnamed = 141;
pub const _SC_DEVICE_IO: C2RustUnnamed = 140;
pub const _SC_THREAD_CPUTIME: C2RustUnnamed = 139;
pub const _SC_CPUTIME: C2RustUnnamed = 138;
pub const _SC_CLOCK_SELECTION: C2RustUnnamed = 137;
pub const _SC_C_LANG_SUPPORT_R: C2RustUnnamed = 136;
pub const _SC_C_LANG_SUPPORT: C2RustUnnamed = 135;
pub const _SC_BASE: C2RustUnnamed = 134;
pub const _SC_BARRIERS: C2RustUnnamed = 133;
pub const _SC_ADVISORY_INFO: C2RustUnnamed = 132;
pub const _SC_XOPEN_REALTIME_THREADS: C2RustUnnamed = 131;
pub const _SC_XOPEN_REALTIME: C2RustUnnamed = 130;
pub const _SC_XOPEN_LEGACY: C2RustUnnamed = 129;
pub const _SC_XBS5_LPBIG_OFFBIG: C2RustUnnamed = 128;
pub const _SC_XBS5_LP64_OFF64: C2RustUnnamed = 127;
pub const _SC_XBS5_ILP32_OFFBIG: C2RustUnnamed = 126;
pub const _SC_XBS5_ILP32_OFF32: C2RustUnnamed = 125;
pub const _SC_NL_TEXTMAX: C2RustUnnamed = 124;
pub const _SC_NL_SETMAX: C2RustUnnamed = 123;
pub const _SC_NL_NMAX: C2RustUnnamed = 122;
pub const _SC_NL_MSGMAX: C2RustUnnamed = 121;
pub const _SC_NL_LANGMAX: C2RustUnnamed = 120;
pub const _SC_NL_ARGMAX: C2RustUnnamed = 119;
pub const _SC_USHRT_MAX: C2RustUnnamed = 118;
pub const _SC_ULONG_MAX: C2RustUnnamed = 117;
pub const _SC_UINT_MAX: C2RustUnnamed = 116;
pub const _SC_UCHAR_MAX: C2RustUnnamed = 115;
pub const _SC_SHRT_MIN: C2RustUnnamed = 114;
pub const _SC_SHRT_MAX: C2RustUnnamed = 113;
pub const _SC_SCHAR_MIN: C2RustUnnamed = 112;
pub const _SC_SCHAR_MAX: C2RustUnnamed = 111;
pub const _SC_SSIZE_MAX: C2RustUnnamed = 110;
pub const _SC_NZERO: C2RustUnnamed = 109;
pub const _SC_MB_LEN_MAX: C2RustUnnamed = 108;
pub const _SC_WORD_BIT: C2RustUnnamed = 107;
pub const _SC_LONG_BIT: C2RustUnnamed = 106;
pub const _SC_INT_MIN: C2RustUnnamed = 105;
pub const _SC_INT_MAX: C2RustUnnamed = 104;
pub const _SC_CHAR_MIN: C2RustUnnamed = 103;
pub const _SC_CHAR_MAX: C2RustUnnamed = 102;
pub const _SC_CHAR_BIT: C2RustUnnamed = 101;
pub const _SC_XOPEN_XPG4: C2RustUnnamed = 100;
pub const _SC_XOPEN_XPG3: C2RustUnnamed = 99;
pub const _SC_XOPEN_XPG2: C2RustUnnamed = 98;
pub const _SC_2_UPE: C2RustUnnamed = 97;
pub const _SC_2_C_VERSION: C2RustUnnamed = 96;
pub const _SC_2_CHAR_TERM: C2RustUnnamed = 95;
pub const _SC_XOPEN_SHM: C2RustUnnamed = 94;
pub const _SC_XOPEN_ENH_I18N: C2RustUnnamed = 93;
pub const _SC_XOPEN_CRYPT: C2RustUnnamed = 92;
pub const _SC_XOPEN_UNIX: C2RustUnnamed = 91;
pub const _SC_XOPEN_XCU_VERSION: C2RustUnnamed = 90;
pub const _SC_XOPEN_VERSION: C2RustUnnamed = 89;
pub const _SC_PASS_MAX: C2RustUnnamed = 88;
pub const _SC_ATEXIT_MAX: C2RustUnnamed = 87;
pub const _SC_AVPHYS_PAGES: C2RustUnnamed = 86;
pub const _SC_PHYS_PAGES: C2RustUnnamed = 85;
pub const _SC_NPROCESSORS_ONLN: C2RustUnnamed = 84;
pub const _SC_NPROCESSORS_CONF: C2RustUnnamed = 83;
pub const _SC_THREAD_PROCESS_SHARED: C2RustUnnamed = 82;
pub const _SC_THREAD_PRIO_PROTECT: C2RustUnnamed = 81;
pub const _SC_THREAD_PRIO_INHERIT: C2RustUnnamed = 80;
pub const _SC_THREAD_PRIORITY_SCHEDULING: C2RustUnnamed = 79;
pub const _SC_THREAD_ATTR_STACKSIZE: C2RustUnnamed = 78;
pub const _SC_THREAD_ATTR_STACKADDR: C2RustUnnamed = 77;
pub const _SC_THREAD_THREADS_MAX: C2RustUnnamed = 76;
pub const _SC_THREAD_STACK_MIN: C2RustUnnamed = 75;
pub const _SC_THREAD_KEYS_MAX: C2RustUnnamed = 74;
pub const _SC_THREAD_DESTRUCTOR_ITERATIONS: C2RustUnnamed = 73;
pub const _SC_TTY_NAME_MAX: C2RustUnnamed = 72;
pub const _SC_LOGIN_NAME_MAX: C2RustUnnamed = 71;
pub const _SC_GETPW_R_SIZE_MAX: C2RustUnnamed = 70;
pub const _SC_GETGR_R_SIZE_MAX: C2RustUnnamed = 69;
pub const _SC_THREAD_SAFE_FUNCTIONS: C2RustUnnamed = 68;
pub const _SC_THREADS: C2RustUnnamed = 67;
pub const _SC_T_IOV_MAX: C2RustUnnamed = 66;
pub const _SC_PII_OSI_M: C2RustUnnamed = 65;
pub const _SC_PII_OSI_CLTS: C2RustUnnamed = 64;
pub const _SC_PII_OSI_COTS: C2RustUnnamed = 63;
pub const _SC_PII_INTERNET_DGRAM: C2RustUnnamed = 62;
pub const _SC_PII_INTERNET_STREAM: C2RustUnnamed = 61;
pub const _SC_IOV_MAX: C2RustUnnamed = 60;
pub const _SC_UIO_MAXIOV: C2RustUnnamed = 60;
pub const _SC_SELECT: C2RustUnnamed = 59;
pub const _SC_POLL: C2RustUnnamed = 58;
pub const _SC_PII_OSI: C2RustUnnamed = 57;
pub const _SC_PII_INTERNET: C2RustUnnamed = 56;
pub const _SC_PII_SOCKET: C2RustUnnamed = 55;
pub const _SC_PII_XTI: C2RustUnnamed = 54;
pub const _SC_PII: C2RustUnnamed = 53;
pub const _SC_2_LOCALEDEF: C2RustUnnamed = 52;
pub const _SC_2_SW_DEV: C2RustUnnamed = 51;
pub const _SC_2_FORT_RUN: C2RustUnnamed = 50;
pub const _SC_2_FORT_DEV: C2RustUnnamed = 49;
pub const _SC_2_C_DEV: C2RustUnnamed = 48;
pub const _SC_2_C_BIND: C2RustUnnamed = 47;
pub const _SC_2_VERSION: C2RustUnnamed = 46;
pub const _SC_CHARCLASS_NAME_MAX: C2RustUnnamed = 45;
pub const _SC_RE_DUP_MAX: C2RustUnnamed = 44;
pub const _SC_LINE_MAX: C2RustUnnamed = 43;
pub const _SC_EXPR_NEST_MAX: C2RustUnnamed = 42;
pub const _SC_EQUIV_CLASS_MAX: C2RustUnnamed = 41;
pub const _SC_COLL_WEIGHTS_MAX: C2RustUnnamed = 40;
pub const _SC_BC_STRING_MAX: C2RustUnnamed = 39;
pub const _SC_BC_SCALE_MAX: C2RustUnnamed = 38;
pub const _SC_BC_DIM_MAX: C2RustUnnamed = 37;
pub const _SC_BC_BASE_MAX: C2RustUnnamed = 36;
pub const _SC_TIMER_MAX: C2RustUnnamed = 35;
pub const _SC_SIGQUEUE_MAX: C2RustUnnamed = 34;
pub const _SC_SEM_VALUE_MAX: C2RustUnnamed = 33;
pub const _SC_SEM_NSEMS_MAX: C2RustUnnamed = 32;
pub const _SC_RTSIG_MAX: C2RustUnnamed = 31;
pub const _SC_PAGESIZE: C2RustUnnamed = 30;
pub const _SC_VERSION: C2RustUnnamed = 29;
pub const _SC_MQ_PRIO_MAX: C2RustUnnamed = 28;
pub const _SC_MQ_OPEN_MAX: C2RustUnnamed = 27;
pub const _SC_DELAYTIMER_MAX: C2RustUnnamed = 26;
pub const _SC_AIO_PRIO_DELTA_MAX: C2RustUnnamed = 25;
pub const _SC_AIO_MAX: C2RustUnnamed = 24;
pub const _SC_AIO_LISTIO_MAX: C2RustUnnamed = 23;
pub const _SC_SHARED_MEMORY_OBJECTS: C2RustUnnamed = 22;
pub const _SC_SEMAPHORES: C2RustUnnamed = 21;
pub const _SC_MESSAGE_PASSING: C2RustUnnamed = 20;
pub const _SC_MEMORY_PROTECTION: C2RustUnnamed = 19;
pub const _SC_MEMLOCK_RANGE: C2RustUnnamed = 18;
pub const _SC_MEMLOCK: C2RustUnnamed = 17;
pub const _SC_MAPPED_FILES: C2RustUnnamed = 16;
pub const _SC_FSYNC: C2RustUnnamed = 15;
pub const _SC_SYNCHRONIZED_IO: C2RustUnnamed = 14;
pub const _SC_PRIORITIZED_IO: C2RustUnnamed = 13;
pub const _SC_ASYNCHRONOUS_IO: C2RustUnnamed = 12;
pub const _SC_TIMERS: C2RustUnnamed = 11;
pub const _SC_PRIORITY_SCHEDULING: C2RustUnnamed = 10;
pub const _SC_REALTIME_SIGNALS: C2RustUnnamed = 9;
pub const _SC_SAVED_IDS: C2RustUnnamed = 8;
pub const _SC_JOB_CONTROL: C2RustUnnamed = 7;
pub const _SC_TZNAME_MAX: C2RustUnnamed = 6;
pub const _SC_STREAM_MAX: C2RustUnnamed = 5;
pub const _SC_OPEN_MAX: C2RustUnnamed = 4;
pub const _SC_NGROUPS_MAX: C2RustUnnamed = 3;
pub const _SC_CLK_TCK: C2RustUnnamed = 2;
pub const _SC_CHILD_MAX: C2RustUnnamed = 1;
pub const _SC_ARG_MAX: C2RustUnnamed = 0;
pub type uint16_t = __uint16_t;
pub type uint32_t = __uint32_t;
pub type uint64_t = __uint64_t;
pub type __socket_type = libc::c_uint;
pub const SOCK_NONBLOCK: __socket_type = 2048;
pub const SOCK_CLOEXEC: __socket_type = 524288;
pub const SOCK_PACKET: __socket_type = 10;
pub const SOCK_DCCP: __socket_type = 6;
pub const SOCK_SEQPACKET: __socket_type = 5;
pub const SOCK_RDM: __socket_type = 4;
pub const SOCK_RAW: __socket_type = 3;
pub const SOCK_DGRAM: __socket_type = 2;
pub const SOCK_STREAM: __socket_type = 1;
pub type sa_family_t = libc::c_ushort;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct sockaddr {
    pub sa_family: sa_family_t,
    pub sa_data: [libc::c_char; 14],
}
pub type in_addr_t = uint32_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct in_addr {
    pub s_addr: in_addr_t,
}
pub type in_port_t = uint16_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct sockaddr_in {
    pub sin_family: sa_family_t,
    pub sin_port: in_port_t,
    pub sin_addr: in_addr,
    pub sin_zero: [libc::c_uchar; 8],
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct timezone {
    pub tz_minuteswest: libc::c_int,
    pub tz_dsttime: libc::c_int,
}
pub type __timezone_ptr_t = *mut timezone;
pub type nfds_t = libc::c_ulong;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct pollfd {
    pub fd: libc::c_int,
    pub events: libc::c_short,
    pub revents: libc::c_short,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct tm {
    pub tm_sec: libc::c_int,
    pub tm_min: libc::c_int,
    pub tm_hour: libc::c_int,
    pub tm_mday: libc::c_int,
    pub tm_mon: libc::c_int,
    pub tm_year: libc::c_int,
    pub tm_wday: libc::c_int,
    pub tm_yday: libc::c_int,
    pub tm_isdst: libc::c_int,
    pub tm_gmtoff: libc::c_long,
    pub tm_zone: *const libc::c_char,
}
pub type u8_t = u_int8_t;
pub type u16_t = u_int16_t;
pub type u32_t = u_int32_t;
pub type sockfd = libc::c_int;
pub type eventfd_t = uint64_t;
pub type event_type = libc::c_uint;
pub const EVENT_WAKE: event_type = 2;
pub const EVENT_READ: event_type = 1;
pub const EVENT_TIMEOUT: event_type = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed_0 {
    pub ifru_addr: sockaddr,
    pub ifru_dstaddr: sockaddr,
    pub ifru_broadaddr: sockaddr,
    pub ifru_netmask: sockaddr,
    pub ifru_hwaddr: sockaddr,
    pub ifru_flags: libc::c_short,
    pub ifru_ivalue: libc::c_int,
    pub ifru_mtu: libc::c_int,
    pub ifru_map: ifmap,
    pub ifru_slave: [libc::c_char; 16],
    pub ifru_newname: [libc::c_char; 16],
    pub ifru_data: __caddr_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ifmap {
    pub mem_start: libc::c_ulong,
    pub mem_end: libc::c_ulong,
    pub base_addr: libc::c_ushort,
    pub irq: libc::c_uchar,
    pub dma: libc::c_uchar,
    pub port: libc::c_uchar,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ifreq {
    pub ifr_ifrn: C2RustUnnamed_1,
    pub ifr_ifru: C2RustUnnamed_0,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed_1 {
    pub ifrn_name: [libc::c_char; 16],
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed_2 {
    pub ifcu_buf: __caddr_t,
    pub ifcu_req: *mut ifreq,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ifconf {
    pub ifc_len: libc::c_int,
    pub ifc_ifcu: C2RustUnnamed_2,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct addrinfo {
    pub ai_flags: libc::c_int,
    pub ai_family: libc::c_int,
    pub ai_socktype: libc::c_int,
    pub ai_protocol: libc::c_int,
    pub ai_addrlen: socklen_t,
    pub ai_addr: *mut sockaddr,
    pub ai_canonname: *mut libc::c_char,
    pub ai_next: *mut addrinfo,
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// logging functions
#[no_mangle]
pub unsafe extern "C" fn logtime() -> *const libc::c_char {
    static mut buf: [libc::c_char; 100] = [0; 100];
    let mut tv: timeval = timeval{tv_sec: 0, tv_usec: 0,};
    gettimeofday(&mut tv, 0 as *mut timezone);
    strftime(buf.as_mut_ptr(),
             ::std::mem::size_of::<[libc::c_char; 100]>() as libc::c_ulong,
             b"[%T.\x00" as *const u8 as *const libc::c_char,
             localtime(&mut tv.tv_sec));
    sprintf(buf.as_mut_ptr().offset(strlen(buf.as_mut_ptr()) as isize),
            b"%06ld]\x00" as *const u8 as *const libc::c_char, tv.tv_usec);
    return buf.as_mut_ptr();
}
#[no_mangle]
pub unsafe extern "C" fn logprint(mut fmt: *const libc::c_char,
                                  mut args: ...) {
    let mut args_0: ::std::ffi::VaListImpl;
    args_0 = args.clone();
    vfprintf(stderr, fmt, args_0.as_va_list());
    fflush(stderr);
}
// cmdline parsing
#[no_mangle]
pub unsafe extern "C" fn next_param(mut src: *mut libc::c_char,
                                    mut c: libc::c_char)
 -> *mut libc::c_char {
    static mut str: *mut libc::c_char =
        0 as *const libc::c_char as *mut libc::c_char;
    let mut ptr: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut ret: *mut libc::c_char = 0 as *mut libc::c_char;
    if !src.is_null() { str = src }
    if !str.is_null() &&
           { ptr = strchr(str, c as libc::c_int); !ptr.is_null() } {
        ret = str;
        *ptr = '\u{0}' as i32 as libc::c_char;
        str = ptr.offset(1 as libc::c_int as isize)
    } else { ret = str; str = 0 as *mut libc::c_char }
    return if !ret.is_null() &&
                  *ret.offset(0 as libc::c_int as isize) as libc::c_int != 0 {
               ret
           } else { 0 as *mut libc::c_char };
}
// clock
#[no_mangle]
pub unsafe extern "C" fn gettime_ms() -> u32_t {
    let mut ts: timespec = timespec{tv_sec: 0, tv_nsec: 0,};
    if clock_gettime(1 as libc::c_int, &mut ts) == 0 {
        return (ts.tv_sec * 1000 as libc::c_int as libc::c_long +
                    ts.tv_nsec / 1000000 as libc::c_int as libc::c_long) as
                   u32_t
    }
    let mut tv: timeval = timeval{tv_sec: 0, tv_usec: 0,};
    gettimeofday(&mut tv, 0 as *mut timezone);
    return (tv.tv_sec * 1000 as libc::c_int as libc::c_long +
                tv.tv_usec / 1000 as libc::c_int as libc::c_long) as u32_t;
}
// mac address
// search first 4 interfaces returned by IFCONF
#[no_mangle]
pub unsafe extern "C" fn get_mac(mut mac: *mut u8_t) {
    let mut utmac: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut ifc: ifconf =
        ifconf{ifc_len: 0,
               ifc_ifcu: C2RustUnnamed_2{ifcu_buf: 0 as *mut libc::c_char,},};
    let mut ifr: *mut ifreq = 0 as *mut ifreq;
    let mut ifend: *mut ifreq = 0 as *mut ifreq;
    let mut ifreq: ifreq =
        ifreq{ifr_ifrn: C2RustUnnamed_1{ifrn_name: [0; 16],},
              ifr_ifru:
                  C2RustUnnamed_0{ifru_addr:
                                      sockaddr{sa_family: 0,
                                               sa_data: [0; 14],},},};
    let mut ifs: [ifreq; 4] =
        [ifreq{ifr_ifrn: C2RustUnnamed_1{ifrn_name: [0; 16],},
               ifr_ifru:
                   C2RustUnnamed_0{ifru_addr:
                                       sockaddr{sa_family: 0,
                                                sa_data: [0; 14],},},}; 4];
    utmac = getenv(b"UTMAC\x00" as *const u8 as *const libc::c_char);
    if !utmac.is_null() {
        if strlen(utmac) == 17 as libc::c_int as libc::c_ulong {
            if sscanf(utmac,
                      b"%2hhx:%2hhx:%2hhx:%2hhx:%2hhx:%2hhx\x00" as *const u8
                          as *const libc::c_char,
                      &mut *mac.offset(0 as libc::c_int as isize) as
                          *mut u8_t,
                      &mut *mac.offset(1 as libc::c_int as isize) as
                          *mut u8_t,
                      &mut *mac.offset(2 as libc::c_int as isize) as
                          *mut u8_t,
                      &mut *mac.offset(3 as libc::c_int as isize) as
                          *mut u8_t,
                      &mut *mac.offset(4 as libc::c_int as isize) as
                          *mut u8_t,
                      &mut *mac.offset(5 as libc::c_int as isize) as
                          *mut u8_t) == 6 as libc::c_int {
                return
            }
        }
    }
    let ref mut fresh0 = *mac.offset(5 as libc::c_int as isize);
    *fresh0 = 0 as libc::c_int as u8_t;
    let ref mut fresh1 = *mac.offset(4 as libc::c_int as isize);
    *fresh1 = *fresh0;
    let ref mut fresh2 = *mac.offset(3 as libc::c_int as isize);
    *fresh2 = *fresh1;
    let ref mut fresh3 = *mac.offset(2 as libc::c_int as isize);
    *fresh3 = *fresh2;
    let ref mut fresh4 = *mac.offset(1 as libc::c_int as isize);
    *fresh4 = *fresh3;
    *mac.offset(0 as libc::c_int as isize) = *fresh4;
    let mut s: libc::c_int =
        socket(2 as libc::c_int, SOCK_DGRAM as libc::c_int, 0 as libc::c_int);
    ifc.ifc_len =
        ::std::mem::size_of::<[ifreq; 4]>() as libc::c_ulong as libc::c_int;
    ifc.ifc_ifcu.ifcu_req = ifs.as_mut_ptr();
    if ioctl(s, 0x8912 as libc::c_int as libc::c_ulong,
             &mut ifc as *mut ifconf) == 0 as libc::c_int {
        ifend =
            ifs.as_mut_ptr().offset((ifc.ifc_len as
                                         libc::c_ulong).wrapping_div(::std::mem::size_of::<ifreq>()
                                                                         as
                                                                         libc::c_ulong)
                                        as isize);
        ifr = ifc.ifc_ifcu.ifcu_req;
        while ifr < ifend {
            if (*ifr).ifr_ifru.ifru_addr.sa_family as libc::c_int ==
                   2 as libc::c_int {
                strncpy(ifreq.ifr_ifrn.ifrn_name.as_mut_ptr(),
                        (*ifr).ifr_ifrn.ifrn_name.as_mut_ptr(),
                        (::std::mem::size_of::<[libc::c_char; 16]>() as
                             libc::c_ulong).wrapping_sub(1 as libc::c_int as
                                                             libc::c_ulong));
                if ioctl(s, 0x8927 as libc::c_int as libc::c_ulong,
                         &mut ifreq as *mut ifreq) == 0 as libc::c_int {
                    memcpy(mac as *mut libc::c_void,
                           ifreq.ifr_ifru.ifru_hwaddr.sa_data.as_mut_ptr() as
                               *const libc::c_void,
                           6 as libc::c_int as libc::c_ulong);
                    if *mac.offset(0 as libc::c_int as isize) as libc::c_int +
                           *mac.offset(1 as libc::c_int as isize) as
                               libc::c_int +
                           *mac.offset(2 as libc::c_int as isize) as
                               libc::c_int != 0 as libc::c_int {
                        break ;
                    }
                }
            }
            ifr = ifr.offset(1)
        }
    }
    close(s);
}
#[no_mangle]
pub unsafe extern "C" fn set_nonblock(mut s: sockfd) {
    let mut flags: libc::c_int = fcntl(s, 3 as libc::c_int, 0 as libc::c_int);
    fcntl(s, 4 as libc::c_int, flags | 0o4000 as libc::c_int);
}
// connect for socket already set to non blocking with timeout in seconds
#[no_mangle]
pub unsafe extern "C" fn connect_timeout(mut sock: sockfd,
                                         mut addr: *const sockaddr,
                                         mut addrlen: socklen_t,
                                         mut timeout: libc::c_int)
 -> libc::c_int {
    let mut w: fd_set = fd_set{__fds_bits: [0; 16],};
    let mut e: fd_set = fd_set{__fds_bits: [0; 16],};
    let mut tval: timeval = timeval{tv_sec: 0, tv_usec: 0,};
    if connect(sock, addr, addrlen) < 0 as libc::c_int {
        if *__errno_location() != 115 as libc::c_int {
            return -(1 as libc::c_int)
        }
    }
    let mut __d0: libc::c_int = 0;
    let mut __d1: libc::c_int = 0;
    let fresh5 = &mut __d0;
    let fresh6;
    let fresh7 = &mut __d1;
    let fresh8;
    let fresh9 =
        (::std::mem::size_of::<fd_set>() as
             libc::c_ulong).wrapping_div(::std::mem::size_of::<__fd_mask>() as
                                             libc::c_ulong);
    let fresh10 =
        &mut *w.__fds_bits.as_mut_ptr().offset(0 as libc::c_int as isize) as
            *mut __fd_mask;
    asm!("cld; rep; stosq" : "={cx}" (fresh6), "={di}" (fresh8) : "{ax}"
         (0 as libc::c_int), "0"
         (c2rust_asm_casts::AsmCast::cast_in(fresh5, fresh9)), "1"
         (c2rust_asm_casts::AsmCast::cast_in(fresh7, fresh10)) : "memory" :
         "volatile");
    c2rust_asm_casts::AsmCast::cast_out(fresh5, fresh9, fresh6);
    c2rust_asm_casts::AsmCast::cast_out(fresh7, fresh10, fresh8);
    w.__fds_bits[(sock /
                      (8 as libc::c_int *
                           ::std::mem::size_of::<__fd_mask>() as libc::c_ulong
                               as libc::c_int)) as usize] |=
        ((1 as libc::c_ulong) <<
             sock %
                 (8 as libc::c_int *
                      ::std::mem::size_of::<__fd_mask>() as libc::c_ulong as
                          libc::c_int)) as __fd_mask;
    e = w;
    tval.tv_sec = timeout as __time_t;
    tval.tv_usec = 0 as libc::c_int as __suseconds_t;
    // only return 0 if w set and sock error is zero, otherwise return error code
    if select(sock + 1 as libc::c_int, 0 as *mut fd_set, &mut w, &mut e,
              (if timeout != 0 { &mut tval } else { 0 as *mut timeval })) ==
           1 as libc::c_int &&
           w.__fds_bits[(sock /
                             (8 as libc::c_int *
                                  ::std::mem::size_of::<__fd_mask>() as
                                      libc::c_ulong as libc::c_int)) as usize]
               &
               ((1 as libc::c_ulong) <<
                    sock %
                        (8 as libc::c_int *
                             ::std::mem::size_of::<__fd_mask>() as
                                 libc::c_ulong as libc::c_int)) as __fd_mask
               != 0 as libc::c_int as libc::c_long {
        let mut error: libc::c_int = 0 as libc::c_int;
        let mut len: socklen_t =
            ::std::mem::size_of::<libc::c_int>() as libc::c_ulong as
                socklen_t;
        getsockopt(sock, 1 as libc::c_int, 4 as libc::c_int,
                   &mut error as *mut libc::c_int as *mut libc::c_void,
                   &mut len);
        return error
    }
    return -(1 as libc::c_int);
}
#[no_mangle]
pub unsafe extern "C" fn server_addr(mut server: *mut libc::c_char,
                                     mut ip_ptr: *mut in_addr_t,
                                     mut port_ptr: *mut libc::c_uint) {
    let mut res: *mut addrinfo = 0 as *mut addrinfo;
    let mut hints: addrinfo =
        addrinfo{ai_flags: 0,
                 ai_family: 0,
                 ai_socktype: 0,
                 ai_protocol: 0,
                 ai_addrlen: 0,
                 ai_addr: 0 as *mut sockaddr,
                 ai_canonname: 0 as *mut libc::c_char,
                 ai_next: 0 as *mut addrinfo,};
    let mut port: *const libc::c_char = 0 as *const libc::c_char;
    if !strtok(server, b":\x00" as *const u8 as *const libc::c_char).is_null()
       {
        port =
            strtok(0 as *mut libc::c_char,
                   b":\x00" as *const u8 as *const libc::c_char);
        if !port.is_null() { *port_ptr = atoi(port) as libc::c_uint }
    }
    memset(&mut hints as *mut addrinfo as *mut libc::c_void, 0 as libc::c_int,
           ::std::mem::size_of::<addrinfo>() as libc::c_ulong);
    hints.ai_family = 2 as libc::c_int;
    getaddrinfo(server, 0 as *const libc::c_char, &mut hints, &mut res);
    if !res.is_null() && !(*res).ai_addr.is_null() {
        *ip_ptr = (*((*res).ai_addr as *mut sockaddr_in)).sin_addr.s_addr
    }
    if !res.is_null() { freeaddrinfo(res); };
}
#[no_mangle]
pub unsafe extern "C" fn set_readwake_handles(mut handles: *mut pollfd,
                                              mut s: sockfd,
                                              mut e: libc::c_int) {
    (*handles.offset(0 as libc::c_int as isize)).fd = s;
    (*handles.offset(1 as libc::c_int as isize)).fd = e;
    (*handles.offset(0 as libc::c_int as isize)).events =
        0x1 as libc::c_int as libc::c_short;
    (*handles.offset(1 as libc::c_int as isize)).events =
        0x1 as libc::c_int as libc::c_short;
}
#[no_mangle]
pub unsafe extern "C" fn wait_readwake(mut handles: *mut pollfd,
                                       mut timeout: libc::c_int)
 -> event_type {
    if poll(handles, 2 as libc::c_int as nfds_t, timeout) > 0 as libc::c_int {
        if (*handles.offset(0 as libc::c_int as isize)).revents != 0 {
            return EVENT_READ
        }
        if (*handles.offset(1 as libc::c_int as isize)).revents != 0 {
            let mut val: eventfd_t = 0;
            eventfd_read((*handles.offset(1 as libc::c_int as isize)).fd,
                         &mut val);
            return EVENT_WAKE
        }
    }
    return EVENT_TIMEOUT;
}
// pack/unpack to network byte order
#[no_mangle]
pub unsafe extern "C" fn packN(mut dest: *mut u32_t, mut val: u32_t) {
    let mut ptr: *mut u8_t = dest as *mut u8_t;
    *ptr =
        (val >> 24 as libc::c_int & 0xff as libc::c_int as libc::c_uint) as
            u8_t;
    *ptr.offset(1 as libc::c_int as isize) =
        (val >> 16 as libc::c_int & 0xff as libc::c_int as libc::c_uint) as
            u8_t;
    *ptr.offset(2 as libc::c_int as isize) =
        (val >> 8 as libc::c_int & 0xff as libc::c_int as libc::c_uint) as
            u8_t;
    *ptr.offset(3 as libc::c_int as isize) =
        (val & 0xff as libc::c_int as libc::c_uint) as u8_t;
}
#[no_mangle]
pub unsafe extern "C" fn packn(mut dest: *mut u16_t, mut val: u16_t) {
    let mut ptr: *mut u8_t = dest as *mut u8_t;
    *ptr =
        (val as libc::c_int >> 8 as libc::c_int & 0xff as libc::c_int) as
            u8_t;
    *ptr.offset(1 as libc::c_int as isize) =
        (val as libc::c_int & 0xff as libc::c_int) as u8_t;
}
#[no_mangle]
pub unsafe extern "C" fn unpackN(mut src: *mut u32_t) -> u32_t {
    let mut ptr: *mut u8_t = src as *mut u8_t;
    return ((*ptr as libc::c_int) << 24 as libc::c_int |
                (*ptr.offset(1 as libc::c_int as isize) as libc::c_int) <<
                    16 as libc::c_int |
                (*ptr.offset(2 as libc::c_int as isize) as libc::c_int) <<
                    8 as libc::c_int |
                *ptr.offset(3 as libc::c_int as isize) as libc::c_int) as
               u32_t;
}
#[no_mangle]
pub unsafe extern "C" fn unpackn(mut src: *mut u16_t) -> u16_t {
    let mut ptr: *mut u8_t = src as *mut u8_t;
    return ((*ptr as libc::c_int) << 8 as libc::c_int |
                *ptr.offset(1 as libc::c_int as isize) as libc::c_int) as
               u16_t;
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
#[no_mangle]
pub unsafe extern "C" fn touch_memory(mut buf: *mut u8_t, mut size: size_t) {
    let mut ptr: *mut u8_t = 0 as *mut u8_t;
    ptr = buf;
    while ptr < buf.offset(size as isize) {
        *ptr = 0 as libc::c_int as u8_t;
        ptr = ptr.offset(sysconf(_SC_PAGESIZE as libc::c_int) as isize)
    };
}
